## ponyprog 3.1.4%2Bds

=== distribution/osx/CMakeLists.txt ===
#OPTION(PONYPROG_INSTALL_AQSIS "Include Aqsis in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_CGKIT "Include cgkit in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYGTK "Include PyGTK in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYOPENGL "Include PyOpenGL in the K-3D installer" OFF)
#OPTION(PONYPROG_INSTALL_PYTHON "Include Python in the K-3D installer" ON)
OPTION(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE "Include an option to build a MacOSX PackageMaker package." OFF)

SET(PONYPROG_BINARY_LOCATIONS )
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-make-module-proxy")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-renderframe")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-renderjob")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-resource-compiler")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-sl2xml")
LIST(APPEND PONYPROG_BINARY_LOCATIONS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ponyprog-uuidgen")

FILE(GLOB_RECURSE PONYPROG_PLUGIN_BINARIES "${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR}/ponyprog/plugins/*.module")
LIST(APPEND PONYPROG_BINARY_LOCATIONS ${PONYPROG_PLUGIN_BINARIES})

# Enable automatic installation of library dependencies ...
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake" @ONLY)
INSTALL(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake")

# Install some runtime dependencies that can't be detected via static analysis ...

# This is an ugly hack, we should be able to detect this automatically, but I'm feeling lazy ...
SET(PONYPROG_MACPORTS_DIR "/opt/local" CACHE PATH "Root directory containing installed MacPorts packages")
MARK_AS_ADVANCED(PONYPROG_MACPORTS_DIR)

INSTALL(
	PROGRAMS
		${PONYPROG_MACPORTS_DIR}/lib/libgailutil.18.dylib
	DESTINATION
		lib
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/gtk-2.0/2.10.0
	DESTINATION
		lib/gtk-2.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/gtk-2.0/modules
	DESTINATION
		lib/gtk-2.0/2.10.0
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/lib/pango
	DESTINATION
		lib
	USE_SOURCE_PERMISSIONS
	)

INSTALL(
	DIRECTORY
		${PONYPROG_MACPORTS_DIR}/etc/gtk-2.0
		${PONYPROG_MACPORTS_DIR}/etc/fonts
		${PONYPROG_MACPORTS_DIR}/etc/pango
	DESTINATION
		etc
	)

# Bundle packaging is always available ...
ADD_SUBDIRECTORY(bundle)

# We optionally support creating packagemaker packages ...
IF(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE)
	ADD_SUBDIRECTORY(packagemaker)
ENDIF(PONYPROG_CREATE_PACKAGEMAKER_PACKAGE)


# INCLUDE(CPack)

## ponyprog 3.1.4%2bds

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="mode=git, uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/, \
  dversionmangle=s/\+ds(\.?\d+)?$//" \
  https://github.com/lancos/ponyprog.git \
  refs/tags/v(\d+\.\d+\.\d+(?:\.?beta[1-9])?)

## ponyprog 3.1.4+ds

=== CMakeLists.txt ===
PROJECT(ponyprog)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
# CMAKE_POLICY(SET CMP0003 OLD)
# CMAKE_POLICY(SET CMP0015 OLD)

IF(WIN32)
    CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

# set the Qt version to 4 or 5
OPTION (USE_QT5 "Using of Qt5 version for compiling" ON)

IF(${USE_QT5})
    SET(USE_QT_VERSION 5)
ELSE(${USE_QT5})
    SET(USE_QT_VERSION 4)
ENDIF(${USE_QT5})

# # SET(FILES_TO_TRANSLATE)
IF(WIN32)
    IF(MSVC)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\msvc2015\\")
    ENDIF()

    IF(MinGW)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\mingw53_32\\")
    ENDIF()
ENDIF()

#disable -rdynamic
# SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
# SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")


# FILE (GLOB TRANSLATIONS_FILES ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts)

# OPTION (UPDATE_TRANSLATIONS "Update source translation ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts" OFF)


MESSAGE(STATUS "Qt version for compiling: " ${USE_QT_VERSION})

OPTION (USE_DEBUGGER "Include in binary file debug information" OFF)

OPTION (USE_PROFILER "Include in binary file profiling information" OFF)


IF(${USE_DEBUGGER})
  SET(CMAKE_BUILD_TYPE Debug)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
ELSE()
  SET(CMAKE_BUILD_TYPE Release)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
ENDIF()

MESSAGE(STATUS "CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)

SET(TARGET_NAME ponyprog )
SET(CMAKE_HELPERS_BINARY_DIR ${PROJECT_SOURCE_DIR}/cmake)
SET(CMAKE_HELPERS_SOURCE_DIR ${PROJECT_SOURCE_DIR}/cmake)
LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")



INCLUDE(OutOfSourceBuild) # Disallow in-source builds

INCLUDE(GenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(Dependencies)


SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(FindLibUSB-1.0)

IF(NOT ${LIBUSB_VERSION} LESS "1.0.16")
  MESSAGE(STATUS "LibUSB version ${LIBUSB_VERSION}")
ELSE()
  MESSAGE(FATAL_ERROR "-- LibUSB version ${LIBUSB_VERSION} TOO OLD! Please Install this library newer as 1.0.16")
ENDIF()


# SET(APP_VERSION "3.1.4")
#
# Set the PonyProg version
# this for generating of version file from HISTORY file
# the idea is to descript all changes in this file, last changes with version are in the top of file
FILE(READ "HISTORY" DESCRIBE_STRING)
STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" APP_VERSION "${DESCRIBE_STRING}" )

MESSAGE(STATUS "Version info: ${APP_VERSION}")
SET(VERSION ${APP_VERSION})

SET(APP_AUTHOR "Claudio Lanconelli")
SET(APP_EMAIL "PonyProg2000@gmail.com")
SET(APP_NAME "PonyProg")
SET(AUTHORWEB "http://www.LancOS.com")
SET(APP_YEAR "2025")

SET(PORTERGQT "Eduard Kalinowski")
SET(PORTERMAIL "eduard_kalinowski@yahoo.de")


IF(WIN32)
  EXECUTE_PROCESS (
    COMMAND "cmd" " /c date /t"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
ELSE()
  EXECUTE_PROCESS (
    COMMAND date +"%d-%m-%Y"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
    STRING(REGEX REPLACE "\"" "" APP_BUILD_DATE ${APP_BUILD_DATE})
ENDIF()

MESSAGE(STATUS "Version build date: ${APP_BUILD_DATE}")

#
SET(PONYPROG_PACKAGE ponyprog)
SET(PONYPROG_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
#SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-${APP_YEAR} ${APP_AUTHOR}, All Rights Reserved.")
SET(PONYPROG_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
# IF(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
# ELSE(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
# ENDIF(MSVC)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions")

# options for gprof
IF(${USE_PROFILER})
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")
  # after execution of program: gprof ./build/ponyprog
  # and get the information from gprof.txt file
  MESSAGE(STATUS "Compile with profiling information")
ELSE()
  MESSAGE(STATUS "Compile without profiling information")
ENDIF()



    FIND_PACKAGE(Qt5 COMPONENTS Core PrintSupport Gui Widgets Multimedia REQUIRED QUIET)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT Qt5Widgets_FOUND)

    IF(NOT Qt5PrintSupport_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 PrintSupport development files are not found. "
        "Qt5PrintSupport development package is to install.")
    ENDIF(NOT Qt5PrintSupport_FOUND)

    IF(NOT Qt5Multimedia_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 Multimedia development files are not found. "
        "Qt5Multimedia development package is to install.")
    ENDIF(NOT Qt5Multimedia_FOUND)

IF (NOT WIN32)
    FIND_PACKAGE ( LibFTDI1 NO_MODULE REQUIRED )

    IF(NOT LibFTDI1_FOUND)
        MESSAGE(FATAL_ERROR "LibFTDI1 files are not found. "
        "need to install LibFTDI1 development packages.")
    ENDIF(NOT LibFTDI1_FOUND)

    INCLUDE ( ${LIBFTDI_USE_FILE} )
ELSE()
    SET ( LIBFTDI_ROOT_DIR     "C:/libftdi1-1.5_devkit_x86_x64_19July2020" )

	SET ( LIBFTDI_LIBRARY      "ftdi1" )
    SET ( LIBFTDIPP_LIBRARY    "ftdipp1" )

    SET ( LIBFTDI_VERSION_STRING "1.5" )
    SET ( LIBFTDI_VERSION_MAJOR  "1" )
    SET ( LIBFTDI_VERSION_MINOR  "5" )

	INCLUDE_DIRECTORIES("${LIBFTDI_ROOT_DIR}/include")
	INCLUDE_DIRECTORIES("${LIBFTDI_ROOT_DIR}/include/libftdi")
	LINK_DIRECTORIES("${LIBFTDI_ROOT_DIR}/lib32")
ENDIF()

INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})

# for this feature install debhelper or
SET(PONYPROG_CPACK_PACKAGE_SHLIBDEPS ON)

    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS})

    #MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")

    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ${Qt5PrintSupport_EXECUTABLE_COMPILE_FLAGS}")

configure_file (
  "${PROJECT_SOURCE_DIR}/SrcPony/version-cmake.h.in"
  "${PROJECT_SOURCE_DIR}/SrcPony/version.h" )


SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

ADD_SUBDIRECTORY(qhexedit2/src)
ADD_SUBDIRECTORY(SrcPony)

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )


#     QT5_ADD_TRANSLATION(APP_TRANSLATIONS ${TRANSLATION})
    QT5_WRAP_CPP(APP_HEADERS_MOC ${HEX_HEADERS} ${PONY_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${PONY_FORMS} )
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})


MESSAGE(STATUS "PONY_RESOURCES ${APP_RESOURCES_RCC}")

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)

message(STATUS "Include dirs ")
get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "dir='${dir}'")
endforeach()


IF(NOT ${USE_DEBUGGER})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_NO_DEBUG -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
ELSE()
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_DEBUG)
ENDIF()

ADD_DEFINITIONS(${Qt5Widgets_DEFINITIONS} ${Qt5PrintSupport_DEFINITIONS} ${Qt5Multimedia_DEFINITIONS} -DQT_PROJECT)

IF(WIN32)
    ADD_DEFINITIONS(-DUNICODE -D_UNICODE)
ENDIF()

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES}
    ${HEX_SOURCES}
    ${PONY_SOURCES}
    ${APP_HEADERS_MOC}
    ${APP_FORMS_HEADERS}
#     ${APP_TRANSLATIONS}
    ${APP_RESOURCES_RCC}
)


TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES})
#MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")

#TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARIES} )
TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARY} ${LIBUSB_LIBRARIES})

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

#message(STATUS "Link Libraries ")
#get_target_property(OUTP ${CMAKE_PROJECT_NAME} LINK_LIBRARIES)
#message(STATUS ${OUTP})


# Setup module enabled/disabled defaults ...
IF(MSVC)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(MSVC)

IF(UNIX AND NOT APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(PONYPROG_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(PONYPROG_ENABLE_SYMBOL_VISIBILITY)

# OPTION(PONYPROG_ENABLE_TESTING "Build the Ponyprog regression test suite." OFF)
# SET(BUILD_TESTING ${PONYPROG_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(PONYPROG_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(PONYPROG_ENABLE_TESTING)

# Capture system configuration
INCLUDE(SystemConfiguration)

# MSVC configuration
IF(MSVC)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(NOT MSVC)
ENDIF(MSVC)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)


IF(MSVC)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)
ELSE(MSVC)
    SET(PONYPROG_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR})
ENDIF(MSVC)

# Setup a macro for compiling resources ...
MACRO(PONYPROG_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(PONYPROG_RESOURCE_COMPILER ponyprog-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS ponyprog-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${PONYPROG_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(PONYPROG_COMPILE_RESOURCE)

# Setup subdirectories ...
PONYPROG_CONDITIONAL_BUILD(MSVC gendef)
#
OPTION(PONYPROG_ENABLE_DISTRIBUTION "Enable distribution targets." ON)
PONYPROG_CONDITIONAL_BUILD(PONYPROG_ENABLE_DISTRIBUTION distribution)

# Hide some cruft ...
MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY)
MARK_AS_ADVANCED(CMAKE_EXECUTABLE_FORMAT)
MARK_AS_ADVANCED(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES)
MARK_AS_ADVANCED(CMAKE_OSX_DEPLOYMENT_TARGET)

=== src/CMakeLists.txt ===
#CMakeLists.txt

SET(HEX_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/commands.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/chunks.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit.cpp)


SET(HEX_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/commands.h
                ${CMAKE_CURRENT_SOURCE_DIR}/chunks.h
                ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit.h)

                
SET(HEX_SOURCES ${HEX_SOURCES}
		PARENT_SCOPE)
		
SET(HEX_HEADERS ${HEX_HEADERS}
		PARENT_SCOPE)


# SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${MAIN_SOURCES} ${MAIN_FORMS} ${MAIN_HEADERS} 
#                  PARENT_SCOPE)

# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== distribution/posix/CMakeLists.txt ===
SET(CPACK_STRIP_FILES TRUE)

SET(CPACK_SET_DESTDIR "ON")

SET(CPACK_INSTALL_PREFIX "/usr") 
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "/usr")

INCLUDE(GNUInstallDirs)

MESSAGE("UDEV_INSTALL_DIR ${UDEV_INSTALL_DIR}")

#SET(UDEV_INSTALL_DIR "/usr/lib/udev/rules.d")
IF(NOT EXISTS "${UDEV_INSTALL_DIR}" OR NOT IS_DIRECTORY "${UDEV_INSTALL_DIR}")
    SET(UDEV_INSTALL_DIR "/lib/udev/rules.d")
ENDIF()

MESSAGE("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")

# SET( CPACK_PACKAGE_GROUP "${PONYPROG_CPACK_PACKAGE_GROUP}" )
SET( CPACK_PACKAGE_LICENSE "${PONYPROG_CPACK_PACKAGE_LICENSE}" )
SET( CPACK_PACKAGE_SHLIBDEPS "${PONYPROG_CPACK_PACKAGE_SHLIBDEPS}" )
# SET( CPACK_PACKAGE_DEPENDS "${PONYPROG_CPACK_PACKAGE_DEPENDS}" )

INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/ponyprog"
        DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT "application"
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons/"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons"
        COMPONENT "application"
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.png"
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang/"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ponyprog/lang/"
        COMPONENT "lang files"
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.utf"
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/distribution/innosetup/"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT "help files" 
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        FILES_MATCHING PATTERN "*.jpg" PATTERN "*.html"
        )

INSTALL(FILES "${PROJECT_SOURCE_DIR}/copyright"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT "application"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
        ) 
# MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")

INSTALL(FILES "${PROJECT_SOURCE_DIR}/udev/rules.d/90-ponyprog.rules"
        DESTINATION "${UDEV_INSTALL_DIR}"
        COMPONENT "application"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
        )

INSTALL(FILES "${PROJECT_SOURCE_DIR}/desktop/ponyprog.desktop"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications/"
        COMPONENT "application"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
        )

SET(CPACK_INSTALL_CMAKE_PROJECTS "${PONYPROG_CPACK_INSTALL_CMAKE_PROJECTS}")

SET(PONYPROG_PACKAGE_DIRECTORY "${CURRENT_BUILD_DIR}")

SET( CPACK_PACKAGE_VENDOR "Lancos" )
# FILE(MAKE_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}")
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR posix ${CMAKE_CURRENT_SOURCE_DIR}")
# MESSAGE("DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

SET(CPACK_COMPONENTS_ALL "application" "lang files" "help files")
SET(CPACK_COMPONENTS_INSTALL "ON")

# if not defined
IF(NOT DEBIAN_ARCHITECTURE)
    execute_process(
      COMMAND dpkg --print-architecture
      OUTPUT_VARIABLE DEBIAN_ARCHITECTURE
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  #SET(DEBIAN_ARCHITECTURE i386) #dpkg --print-architecture is always i386 on intel
ENDIF(NOT DEBIAN_ARCHITECTURE)

IF(DEBIAN_ARCHITECTURE)
    MESSAGE("DEBIAN_ARCHITECTURE ${DEBIAN_ARCHITECTURE}")
    SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}-${DEBIAN_ARCHITECTURE}" )
    SET(DEBIAN_POSTINST postinst.in)

    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-deb.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${DEBIAN_POSTINST} ${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postinst)
    ADD_CUSTOM_TARGET(package-binary-deb
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack
        )
ENDIF()

IF(NOT DEBIAN_ARCHITECTURE)
    FIND_PROGRAM(RPMBUILD
        NAMES rpmbuild
        PATHS "/usr/bin")

    IF ( RPMBUILD )
        GET_FILENAME_COMPONENT(RPMBUILD_PATH ${RPMBUILD} ABSOLUTE)
        MESSAGE(STATUS "Found rpmbuild : ${RPMBUILD_PATH}")
        SET(RPMBUILD_FOUND "YES")
        execute_process(
           COMMAND arch
           OUTPUT_VARIABLE RPM_ARCHITECTURE
           OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    ENDIF ( RPMBUILD )
ENDIF()

IF(RPM_ARCHITECTURE)
    MESSAGE("RPM_ARCHITECTURE ${RPM_ARCHITECTURE}")
    SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}-${RPM_ARCHITECTURE}" )
    SET( RPM_POSTINST postinst.in)

    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-rpm.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${RPM_POSTINST} ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postinst.sh)

    ADD_CUSTOM_TARGET(package-binary-rpm
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack
        )
ENDIF()

# Generate self-extracting tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-stgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack)
ADD_CUSTOM_TARGET(package-binary-stgz
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack
        )

# Generate tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack)
ADD_CUSTOM_TARGET(package-binary-tbz2
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack
        )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack)
ADD_CUSTOM_TARGET(package-binary-tgz
        WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack
        )

# Note ... we intentionally don't provide upload capability for Posix packages, and leave distribution to the experts

# INCLUDE(CPack)

=== distribution/source/CMakeLists.txt ===
SET(PONYPROG_PACKAGE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/PonyProg-${APP_VERSION}")
FILE(MAKE_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}")

# SET (CPACK_SOURCE_IGNORE_FILES "${PONYPROG_CPACK_SOURCE_IGNORE_FILES}")

# Generate source packages
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-tbz2.cpack)
ADD_CUSTOM_TARGET(package-source-tbz2
	WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-tbz2.cpack"
	)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-tgz.cpack)
ADD_CUSTOM_TARGET(package-source-tgz
	WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-tgz.cpack"
	)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-source-zip.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-source-zip.cpack)
ADD_CUSTOM_TARGET(package-source-zip
	WORKING_DIRECTORY "${PONYPROG_PACKAGE_DIRECTORY}"
	COMMAND ${CMAKE_CPACK_COMMAND} --config "${CMAKE_CURRENT_BINARY_DIR}/package-source-zip.cpack"
	)

# INCLUDE(CPack)

=== distribution/win32/nsis/CMakeLists.txt ===
# Generate NSIS installer
SET(bin_dir             .)
SET(lib_dir             .)
SET(lang_dir            ./lang/)
SET(help_dir            .)
SET(license_dir         .)

SET(CPACK_GENERATOR NSIS ZIP)

# set(CPACK_PACKAGE_INSTALL_DIRECTORY "${ROBOMONGO_DISPLAY_FULL_NAME}")
 
FUNCTION(INSTALL_QT_LIBS)
    FOREACH(module ${ARGV})
        SET(target_name Qt5::${module})
        SET(module_name Qt5${module})

        # Get full path to some known Qt library (i.e. /path/to/lib/libQt5Widgets.so.5.5.1)
        GET_TARGET_PROPERTY(target_path Qt5::Core LOCATION)

        # Get folder path of library (i.e. /path/to/lib)
        GET_FILENAME_COMPONENT(qt_lib_dir ${target_path} DIRECTORY)

        # Install single DLL to lib directory
        INSTALL(FILES ${qt_lib_dir}/${module_name}${CMAKE_SHARED_LIBRARY_SUFFIX}
                DESTINATION ${lib_dir}
                )
    ENDFOREACH()
ENDFUNCTION()

INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/ponyprog.exe" 
        DESTINATION ${bin_dir}
        COMPONENT "application" 
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons/"    
        DESTINATION ${bin_dir}
        COMPONENT "application" 
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
        FILES_MATCHING PATTERN "*.png"
        )

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang/" 
        DESTINATION ${lang_dir}
        COMPONENT "lang files" 
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
        FILES_MATCHING PATTERN "*.utf"
        ) 

INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/distribution/innosetup/" 
        DESTINATION ${help_dir}
        COMPONENT "help files" 
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
        FILES_MATCHING PATTERN "*.jpg" PATTERN "*.html"
        ) 
        
INSTALL(FILES "${PROJECT_SOURCE_DIR}/InpOutLib/Win32/inpout32.dll" 
        DESTINATION  ${bin_dir}
        COMPONENT "driver" 
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        ) 
     
INSTALL(FILES "${PROJECT_SOURCE_DIR}/InpOutLib/InstallDriver/InstallDriver.exe" 
        DESTINATION  ${bin_dir}
        COMPONENT "driver" 
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        ) 
        
INSTALL_QT_LIBS(Core Gui Widgets PrintSupport Multimedia)
        
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-nsis.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-nsis.cpack)
ADD_CUSTOM_TARGET(package-binary-nsis
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-nsis.cpack
	)


# INCLUDE(CPack)

=== debian/changelog ===
ponyprog (3.1.4+ds-2) unstable; urgency=medium

  * Team Upload
  * [b41abb1] d/control: Remove myself from Uploaders field

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 01 Nov 2025 08:48:03 +0200

ponyprog (3.1.4+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113417)

 -- Adrian Bunk <bunk@debian.org>  Sun, 26 Oct 2025 12:09:39 +0200

ponyprog (3.1.4+ds-1) unstable; urgency=medium

  * [320247f] New upstream version 3.1.4+ds
  * [303c208] d/control: Bump Standards-Version to 4.7.2
    No further changes needed.
  * [795e444] Rebuild patch queue from patch-queue branch
    Adjusted/updated patch:
    udev-adding-TAG-uaccess-so-users-can-access-the-device.patch
  * [7acb2c1] d/copyright: Update copyright years

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 23 Mar 2025 15:34:42 +0200

=== debian/control ===
Source: ponyprog
Section: utils
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 graphicsmagick-imagemagick-compat,
 libftdi1-dev,
 libftdipp1-dev,
 libusb-dev,
 pkgconf,
 qtbase5-dev,
 qtmultimedia5-dev,
 systemd-dev,
Rules-Requires-Root: binary-targets
Standards-Version: 4.7.2
Homepage: https://github.com/lancos/ponyprog
Vcs-Browser: https://salsa.debian.org/electronics-team/ponyprog
Vcs-Git: https://salsa.debian.org/electronics-team/ponyprog.git

Package: ponyprog
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Serial device programmer
 PonyProg is a serial device programmer software with a user friendly
 GUI framework available for Windows and Linux. It's purpose is reading
 and writing every serial device. With PonyProg and SI-Prog you can
 program Wafercard for SAT, eeprom within GSM, TV or CAR-RADIO.
 Furthermore it can be used as a low cost starter kit for PIC and AVR.
 .
 PonyProg supports AVR, SPI eeprom, AVR micro, I2C bus 8bit eeprom, PIC
 16 micro, PIC 12 micro, AT89S micro and SDE2506 eeprom family chips.
 .
 You can open any HEX, e2p, mot, csm, rom, eep, bin files and burn them
 to uC or PIC. You can even backup the old program on the chip using
 PonyProg. PonyProg enables the user to write, verify and erase data on
 the microchip.
 .
 Also setting fuse bits and locks using PonyProg is possible. You can
 save any HEX file to BIN file or eep file, BIN file to HEX file or MOT
 file and vice versa so you can use PonyProg as converter too. PonyProg
 offers serial or parallel port programming for uC's. You can even change
 polarity of control lines without touching the wires using I/O port setup.
 .
 Using PonyProg together with generic USB2serial based on FTDI adapters will
 work. There are plans on upstream to use libusb to add more USB2serial
 based functionality.
